<?php 

header('Access-Control-Allow-Origin: *');
header('Content-Type: application/json');

require 'connection.php';

function insertAdminNotification($client_id, $date,$title,$Subtitle){
    include 'connection.php';
  
    $sql_notify_insert = "INSERT INTO `admin_notification` (`title`, `subtitle`, `date`,`client_id`) VALUES (?, ?, ?,?)";
    $stmt = $conn->prepare($sql_notify_insert);

    if ($stmt) {
        $stmt->bind_param("sssi",$title, $Subtitle, $date,$client_id);
        $stmt->execute();
        $stmt->close();
        $conn->close();
        return true;
    } else {
        return false;
    }
}

$id = 1;
$query = "SELECT `cname`,`merchant_id`,`mech_secretkey`,`email_api_key`,`email_api_client_id`,`email_api_vender_email`,`email_api_vender_header`,`email_api_vend_id`,`logo` FROM `system_setting` WHERE `id` = ? ";
$stmt = $conn->prepare($query);
$stmt->bind_param('i',$id);
$stmt->execute();
$result = $stmt->get_result();
 if ($result->num_rows > 0) {
     
     $row = $result->fetch_assoc();
     
        $merchant_key           = $row['merchant_id'];
        $merchant_secret        = $row['mech_secretkey'];
        $email_api_key          = $row['email_api_key'];
        $email_api_client_id    = $row['email_api_client_id'];
        $email_api_vender_email = $row['email_api_vender_email'];
        $email_api_vender_header= $row['email_api_vender_header'];
        $email_api_vend_id      = $row['email_api_vend_id'];
        $companyown             = $row['cname'];
        $logo                   = $row['logo'];
        
        
        //payhere response
        
        $merchant_id         = $_POST['merchant_id'];
        $order_id            = $_POST['order_id'];
        $payhere_amount      = $_POST['payhere_amount'];
        $payhere_currency    = $_POST['payhere_currency'];
        $status_code         = $_POST['status_code'];
        $md5sig              = $_POST['md5sig'];
        $client_id           = $_POST['custom_1'];
        
        $local_md5sig = strtoupper(
        md5(
            $merchant_id . 
            $order_id . 
            $payhere_amount . 
            $payhere_currency . 
            $status_code . 
            strtoupper(md5($merchant_secret)) 
        ) 
        );
               
                if (($local_md5sig === $md5sig) AND ($status_code == 2) ){
                    
                        $sql_invDetails = $conn->prepare("SELECT `description`,`status`,`total` FROM `invoice_details` WHERE `invoice_HID` = ?");
                        $sql_invDetails->bind_param("i", $order_id);
                        $sql_invDetails->execute(); 
                        $result_inv = $sql_invDetails->get_result();
                        
                        if($result_inv->num_rows >0 ){
                            
                            $row_invDetails = $result_inv->fetch_assoc();
                            $desc   = $row_invDetails['description'];
                            $status = $row_invDetails['status'];
                            $price  = $row_invDetails['total'];
                            
                            
  
                           
                            
                            
                            if($desc === 'SMS Top-Up'){
                                
                                if($status==='unpaid'){
                                    
                                    $datetimes = date("Y-m-d H:i:s"); 
                                    $statusnew = 'paid';
                                    $sql_update_stl  = "UPDATE `invoice_details` SET `status`=?,`date`=? WHERE `invoice_HID` = ? ";
                                    $res_update_stl  = $conn->prepare($sql_update_stl);
                                    $res_update_stl->bind_param('ssi',$statusnew,$datetimes,$order_id);
                                    $res_update_stl->execute();
                                    
                                    if($res_update_stl){
                                        
                                        $sql_clientDetails = $conn->prepare("SELECT `email`,`current_balance` FROM `clients` WHERE `c_id` = ?");
                                        $sql_clientDetails->bind_param("i", $client_id);
                                        $sql_clientDetails->execute(); 
                                        $result = $sql_clientDetails->get_result();
                                        
                                         if ($result->num_rows > 0) {
                                             
                                             $row_clientDetails = $result->fetch_assoc();
                                             $clientBalance = $row_clientDetails['current_balance'];
                                             $email         = $row_clientDetails['email'];
                                            //  $topup = (float)$payhere_amount;
                                        
                                             $current_balance = $clientBalance + $price;
                                            
                                                $balance_status =0;
                                              
                                                $sql_update_bal  = "UPDATE `clients` SET `current_balance`=?,`low_bal_status`=? WHERE `c_id` = ? ";
                                                $res_update_bal  = $conn->prepare($sql_update_bal);
                                                $res_update_bal->bind_param('sii',$current_balance,$balance_status,$client_id);
                                                $res_update_bal->execute();
                                                
                                                if($res_update_bal){
                                                    
                                                       
                                                        $datetime = date("Y-m-d H:i:s");
                                                        $typemessage= 'topup';
                                                        $sql_account_insert       = "INSERT INTO `account_history` (`current_balance`,`cost`,`new_balance`,`datetime`,`type`,`byID`,`whose`) VALUES (?,?,?,?,?,?,?)";
                                                        $result_account_insert    = $conn->prepare($sql_account_insert);
                                                        $result_account_insert->execute([$clientBalance,$price,$current_balance,$datetime,$typemessage,$client_id,$client_id]); 
                                                        
                                                        if($result_account_insert){
                                                            
                                                            $res ='yes';
                                                            $sql_account_topup       = "INSERT INTO `topup_history` (`datetime`,`current_balance`,`topup`,`new_balance`,`user_id`,`by`,`balance_from`) VALUES (?,?,?,?,?,?,?)";
                                                            $result_account_topup    = $conn->prepare($sql_account_topup);
                                                            $result_account_topup->execute([$datetime, $clientBalance, $price,$current_balance,$client_id,$client_id,$client_id]); 
                                                            
                                                            
                                                                         $log ='Client ID '.$client_id.'Paid for Top Up- '.$price.' LKR for invoice id '.$order_id;
                                                                         $module = 'Account';
                                                                         $title = 'Paid Invoice';
                                                                         insertLog($client_id, $log, $module); 
                                                                         insertAdminNotification($client_id, $datetimes,$title,$log);
                                                                         
                                                                         
                                                                                                                     
                                                        }
                                                    
                                                    
                                                }
                                            
                                            
                                        }
                                        
                                    }
      
                                    
                                    
                                }
                                
                            }else if($desc ==='SMS Platform Set-Up Fee'){
                                
                                    if($status==='unpaid'){
                                     
                                    $datetimes = date("Y-m-d H:i:s"); 
                                    $statusnew = 'paid';
                                    $sql_update_stl  = "UPDATE `invoice_details` SET `status`=?,`date`=? WHERE `invoice_HID` = ? ";
                                    $res_update_stl  = $conn->prepare($sql_update_stl);
                                    $res_update_stl->bind_param('ssi',$statusnew,$datetimes,$order_id);
                                    $res_update_stl->execute();
                                    
                                    if($res_update_stl){
                                       
                                        $sql_clientDetails = $conn->prepare("SELECT `email`,`current_balance` FROM `clients` WHERE `c_id` = ?");
                                        $sql_clientDetails->bind_param("i", $client_id);
                                        $sql_clientDetails->execute(); 
                                        $result = $sql_clientDetails->get_result();
                                       
                                        
                                      if ($result->num_rows > 0) {
                                             
                                             $row_clientDetails = $result->fetch_assoc();
                                          
                                             $email         = $row_clientDetails['email'];
                                      }
                                      $datetimes = date("Y-m-d H:i:s"); 
    
       
                                    
                                
                                             $log ='Client ID '.$client_id.'Paid as Set Fee - '.$price.' LKR for invoice id '.$order_id;
                                             $module = 'Account';
                                             insertLog($client_id, $log, $module);
                                             $title = 'Paid Invoice';
                                             insertAdminNotification($client_id, $datetimes,$title,$log);
                                        
                                    }
                                    
                                }
                                
                            
                            }else{
                                 if($status==='unpaid'){
                                     
                                    $datetimes = date("Y-m-d H:i:s"); 
                                    $statusnew = 'paid';
                                    $sql_update_stl  = "UPDATE `invoice_details` SET `status`=?,`date`=? WHERE `invoice_HID` = ? ";
                                    $res_update_stl  = $conn->prepare($sql_update_stl);
                                    $res_update_stl->bind_param('ssi',$statusnew,$datetimes,$order_id);
                                    $res_update_stl->execute();
                                    
                                    if($res_update_stl){
                                        
                                        $sql_clientDetails = $conn->prepare("SELECT `email`,`current_balance` FROM `clients` WHERE `c_id` = ?");
                                        $sql_clientDetails->bind_param("i", $client_id);
                                        $sql_clientDetails->execute(); 
                                        $result = $sql_clientDetails->get_result();
                                       
                                        
                                      if ($result->num_rows > 0) {
                                             
                                             $row_clientDetails = $result->fetch_assoc();
                                          
                                             $email         = $row_clientDetails['email'];
                                      }
                                      $datetimes = date("Y-m-d H:i:s"); 
    
   
                                
                                             $log ='Client ID '.$client_id.'Paid as Sender ID Fee - '.$price.' LKR for invoice id '.$order_id;
                                             $module = 'Account';
                                             insertLog($client_id, $log, $module);
                                             $title = 'Paid Invoice';
                                             insertAdminNotification($client_id, $datetimes,$title,$log);
                                    }
                                    
                                }
                            }
                            
                        }
                    
                    
                    
                    

                    
                }
     
 }



?>