<?php

header('Access-Control-Allow-Origin: https://portal.ozonesender.com');
header('Access-Control-Allow-Methods: POST');
header('Content-Type: application/json; charset=utf-8');
header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

// Include the connection.php file
require 'connection.php';

function insertLog($addBy, $log, $module) {
    include 'connection.php';
  
    $sql_log_insert = "INSERT INTO `user_log` (`add_by`,`module`,`message`) VALUES (?,?,?)";
    $result_log_insert = $conn->prepare($sql_log_insert);
    $result_log_insert->execute([$addBy, $module, $log]);

    return $result_log_insert;
}

if ($_SERVER['REQUEST_METHOD'] === 'POST') {
    $data = json_decode(file_get_contents('php://input'), true);
    $email = $data['username'];
    $password = $data['password'];

    try {
        // Hash the password for comparison with the stored hashed password
        // Example: $hashedPassword = password_hash($password, PASSWORD_DEFAULT);
        // Make sure to use a secure hashing algorithm and save the hashed password in the database

        $query = "SELECT * FROM `clients` WHERE `email` = ? AND `status` = 1 AND `verification_status` = 1";
        $stmt = $conn->prepare($query);
        $stmt->bind_param('s', $email);
        $stmt->execute();
        $result = $stmt->get_result();

        if ($result->num_rows > 0) {
            $user = $result->fetch_assoc();

            // Verify the entered password against the hashed password from the database
            if (password_verify($password, $user['password'])) {
                $userDetails = [
                    'id' => $user['c_id'],
                    'username' => $user['email'],
                ];

                $response = [
                    'success' => true,
                    'message' => 'Login successful!',
                    'token' => $userDetails,
                ];

                // Perform logging
                $addBy = $user['c_id'];
                $module = 'User Login';
                $log = 'client - ' . $addBy . ' log by using ' . $user['email'];
                insertLog($addBy, $log, $module);
                
            } else {
                $response = [
                    'success' => false,
                    'message' => 'Incorrect email or password.',
                ];
            }
        } else {
            $response = [
                'success' => false,
                'message' => 'User not found or account not verified.',
            ];
        }
    } catch (Exception $e) {
        $response = [
            'success' => false,
            'message' => 'Database error: ' . $e->getMessage(),
        ];
    }

    header('Content-Type: application/json');
    echo json_encode($response);
}




// header('Access-Control-Allow-Origin: *') ;
// header('Access-Control-Allow-Methods: POST');
// header('Content-Type: application/json; charset=utf-8');
// header('Access-Control-Allow-Headers: Content-Type, Access-Control-Allow-Headers, Authorization, X-Requested-With');

// // Include the connection.php file
// require 'connection.php';
// //include 'index.php';

// function insertLog($addBy, $log, $module){
//     include 'connection.php';
  
//     $sql_log_insert       = "INSERT INTO `user_log` (`add_by`,`module`,`message`) VALUES (?,?,?)";
//     $result_log_insert    = $conn->prepare($sql_log_insert);
//     $result_log_insert->execute([$addBy, $module, $log]);  
  
//  return $result_log_insert;

// }

// if ($_SERVER['REQUEST_METHOD'] === 'POST') {
//     $data = json_decode(file_get_contents('php://input'), true);
//     $email = $data['username'];
//     $password = $data['password'];

//     try {
//         $query = "SELECT * FROM `clients` WHERE `email` = ? AND `password`=? AND `status`= 1 AND `verification_status`= 1" ;
//         $stmt = $conn->prepare($query);
//         $stmt->bind_param('ss', $email, $password);
//         $stmt->execute();
//         $result = $stmt->get_result();

//         if ($result->num_rows > 0) {
//             $user = $result->fetch_assoc();
//             $userDetails = [
//               'id' => $user['c_id'],
//               'username' => $user['email'],
              
//           ];

//         //   $tokenPayload = array(
//         //     "user" => $userDetails,
//         //     "exp" => time() + 120 
//         // );
//          //$token = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJpZCI6MSwidXNlcm5hbWUiOiJsYWtpbmR1U3BhcmtnbG9iYWxAZ21haWwuY29tIn0.2aBUcehXttFaU8m-SDUS2o80PFsV5jcjr0_BxAYIZ-o';

//             $response = [
//                 'success' => true,
//                 'message' => 'Login successful!',
//                  'token' => $userDetails,
                
//             ];
//             // $addBy = $user['c_id']
//             // $log     ='User Login'
//             // $module = 'client - '.$addBy.'log by using '.$user['email']

//             // insertLog($addBy, $log, $module)
//         } else {
//             // $addBy = $user['c_id']
//             // $log     ='User Login'
//             // $module = 'client - '.$addBy.'try to log by using '.$user['email']

//             // insertLog($addBy, $log, $module)
//             $response = [
//                 'success' => false,
//                 'message' => 'Incorrect email or password.',
//             ];
//         }
//     } catch (Exception $e) {
//         $response = [
//             'success' => false,
//             'message' => 'Database error: ' . $e->getMessage(),
//         ];
//     }

//     header('Content-Type: application/json');
//     echo json_encode($response);
// }
?>
